package org.incandenza.processing.audioshapes;

import ddf.minim.AudioInput;
import ddf.minim.AudioPlayer;
import ddf.minim.Minim;
import ddf.minim.analysis.BeatDetect;
import ddf.minim.analysis.FFT;
import org.incandenza.processing.audioshapes.entities.Line;
import org.incandenza.processing.audioshapes.entities.Shape2D;
import org.incandenza.processing.audioshapes.utils.EntropyFactory;
import processing.core.PApplet;
import processing.core.PGraphics;

import java.util.ArrayList;


public class MainSketch extends PApplet {
    //shapes
    private ArrayList<Shape2D> shapes = new ArrayList<>();


    private EntropyFactory entropyFactory;
    Minim minim;
    AudioPlayer myAudio;
    //AudioInput myAudio;
    private FFT aFFT;



    private BeatDetect beat;

    // Variables for FFT
    int         delFFT 	= 11;
    int         aM      = 70;
    float       amp     = 30.0f;
    float       aI     	= 0.2f;
    float       aIa  		= aI;
    float       aIStep 	= 0.35f;
    float[]     aData   = new float[delFFT];

    float maxAvg=0.0000000001f;


   private  PGraphics pg;
   public void settings() {

        fullScreen();
   }
   public  void setup() {
       this.entropyFactory = new EntropyFactory();
       for (int i = 0; i < EntropyFactory.LINE_DENSITY; i++) {
          shapes.add(new Line());
       }

        smooth();

        //fullScreen();
        pg = createGraphics(displayWidth, displayHeight);
        background(0);
        color(0,0,0);
     //   textFont(mono, 14);
        minim   = new Minim(this);
         myAudio = minim.loadFile("C:\\Users\\LucaConte\\tmp\\song.mp3",2048); // must be in data folder
         myAudio.loop();
        //myAudio = minim.getLineIn(Minim.MONO);
        aFFT = new FFT(myAudio.bufferSize(), myAudio.sampleRate());
        aFFT.linAverages(delFFT);
        aFFT.window(FFT.GAUSS);
        beat = new BeatDetect(myAudio.bufferSize(),myAudio.sampleRate());

    }

    public void draw() {

        aFFT.forward(myAudio.mix);
        beat.detect(myAudio.mix);
        background(0);
      //  fill(0, 255);
       // color(255,255,255);
        for (Shape2D s: shapes) {
            s.draw(this);
        }
       // noStroke();
       // rect(-10, -10, width+10, height+10);
        //aDelData();
        maxAvg =aFFT.getAvg(0)>maxAvg?aFFT.getAvg(0):maxAvg;
      //  for (int i = 0; i < delFFT; ++i) {
       //     println(i+": " + aFFT.getAvg(i));
        //}
    }

    @Override
    public void keyPressed() {
        super.keyPressed();
        println("max avg: " + maxAvg);
    }

    void aDelData() {
        String b = "[ ";
        String d = "] ";

        for (int i = 0; i < delFFT; ++i) {
            stroke(255,50);
            fill(233f,123f,98f);
            float partI = (aFFT.getAvg(i) * amp) * aIa;
            float tempIndexCon = constrain(partI, 0, aM);
            rect(60 + (i*35), height - 80, 39, -partI);

            fill(255);
            text(b, 40 , height - 30);
            text(d, width - 50, height - 30);
            text( i, 60 + (i*35), height - 30);
            aData[i] = tempIndexCon;
            aIa += aIStep;
        }
        aIa = aI;
    }

    public void stop() {
        myAudio.close();
        minim.stop();
        super.stop();

    }
    public EntropyFactory getEntropyFactory() {
        return entropyFactory;
    }
    public FFT getaFFT() {
        return aFFT;
    }

    public BeatDetect getBeat() {
        return beat;
    }
    public static void main(String[] passedArgs) {
        String[] appletArgs = new String[] { "MySketch" };
        MainSketch ms = new MainSketch();
        PApplet.runSketch(appletArgs,ms);
    }
}
